#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n, k;

vector<pair<ll, int>> t;
vector<ll> tag;

void apply(int x, ll tg) {
    tag[x] += tg;
    t[x].first += tg;
}

void push(int x) {
    if (tag[x]) {
        apply(x << 1, tag[x]);
        apply(x << 1 | 1, tag[x]);
        tag[x] = 0;
    }
}

void pull(int x) {
    t[x] = max(t[x << 1], t[x << 1 | 1]);
}

int sz = 1;

void rangeApply(int l, int r, ll tg, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
        return apply(x, tg);
    }
    int mid = lx + rx >> 1;
    push(x);
    rangeApply(l, r, tg, x << 1, lx, mid);
    rangeApply(l, r, tg, x << 1 | 1, mid, rx);
    pull(x);
}

void build(vector<pair<int, int>> dep) {
    int n = size(dep);
    sz = 1 << __lg(n) + !!(n & (n - 1));
    t.assign(sz << 1, {-1e9, 0}), tag.resize(sz << 1);
    for (int i = 0; i < n; ++i) {
        t[i + sz] = dep[i];
    }
    for (int i = sz - 1; i >= 1; --i) {
        pull(i);
    }
}

vector<vector<int>> adj;
vector<int> jump, depth, tin, tout, parent;

bool isp(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    while (!isp(a, b)) {
        if (isp(jump[a], b)) {
            a = parent[a];
        } else {
            a = jump[a];
        }
    }
    return a;
}

int la(int a, int b) {
    while (depth[a] > b) {
        if (depth[jump[a]] > b) {
            a = jump[a];
        } else {
            a = parent[a];
        }
    }
    return a;
}

int dist(int a, int b) {
    return depth[a] + depth[b] - 2 * depth[lca(a, b)];
}

constexpr int inf = 1e9 + 7;

bool play(int root, int mid) {
    vector<pair<int, ll>> colored;
    int cur = 0;
    int yay = -1;
    mid -= 1;
    while (true) {
        auto [val, leaf] = t[1];
        if (val < 0 || dist(root, leaf) <= mid + 1) {
            yay = 1;
            break;
        }
        if (++cur > k) {
            yay = 0;
            break;
        }
        int c = lca(leaf, root);
        if (depth[leaf] - depth[c] > mid) {
            int v = la(leaf, depth[leaf] - mid);
            rangeApply(tin[v], tout[v], -inf);
            colored.push_back({v, -inf});
        } else {
            int aim = depth[c] + (mid - (depth[leaf] - depth[c]));
            int v = la(root, aim + 1);
            rangeApply(tin[v], tout[v], inf);
            rangeApply(tin[c], tout[c], -inf);
            colored.push_back({v, inf});
            colored.push_back({c, -inf});
        }
    }
    for (auto [x, y] : colored) {
        rangeApply(tin[x], tout[x], -y);
    }
    return yay;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tp;
    cin >> n >> k >> tp;
    if (n == 1) {
        cout << 0 << endl;
        return 0;
    }

    adj.resize(n), jump.resize(n);
    depth.resize(n), tin.resize(n);
    tout.resize(n), parent.resize(n);

    for (int i = 1; i < n; ++i) {
        int a, b;
        if (1) {
            cin >> a >> b;
        } else {
            a = i, b = i + 1;
        }
        a -= 1, b -= 1;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }

    vector<int> ord(n);

    auto dfs = [&](auto self, int v) -> void {
        static int T = 0;
        ord[tin[v] = T++] = v;
        for (int to : adj[v]) {
            if (to == parent[v]) {
                continue;
            }
            parent[to] = v;
            depth[to] = depth[v] + 1;
            int p = jump[v];
            int pp = jump[p];
            if (depth[pp] - depth[p] == depth[p] - depth[v]) {
                jump[to] = pp;
            } else {
                jump[to] = v;
            }
            self(self, to);
        }
        tout[v] = T;
    };

    dfs(dfs, 0);

    vector<pair<int, int>> init(n);
    for (int i = 0; i < n; ++i) {
        init[i] = {depth[ord[i]] + inf, ord[i]};
    }
    build(init);

    vector<int> ans(n);

    auto dfs2 = [&](auto self, int v) -> void {
        int lo = 0, hi = n;
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (play(v, mid)) {
                hi = mid;
            } else {
                lo = mid;
            }
        }
        ans[v] = hi;
        for (int to : adj[v]) {
            if (to == parent[v]) {
                continue;
            }
            rangeApply(tin[to], tout[to], -2);
            self(self, to);
            rangeApply(tin[to], tout[to], 2);
        }
    };

    dfs2(dfs2, 0);

    for (int i = 0; i < 1 + tp * (n - 1); ++i) {
        cout << ans[i] << " ";
    }
    cout << '\n';

    return 0;
}