#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
constexpr int K = int(2e5) * 4;

pair<ll, int> t[K];
ll tag[K];

void apply(int x, ll tg) {
    tag[x] += tg;
    t[x].first += tg;
}

void pull(int x) {
    t[x] = max(t[x << 1], t[x << 1 | 1]);
    t[x].first += tag[x];
}

int sz = 1;

void rangeApply(int l, int r, ll tg, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
        return apply(x, tg);
    }
    int mid = lx + rx >> 1;
    rangeApply(l, r, tg, x << 1, lx, mid);
    rangeApply(l, r, tg, x << 1 | 1, mid, rx);
    pull(x);
}

void build(vector<pair<int, int>> dep) {
    int n = size(dep);
    sz = 1 << __lg(n) + !!(n & (n - 1));
    fill(t, t + (sz << 1), pair<ll, int>{-inf, 0}), fill(tag, tag + (sz << 1), 0);
    for (int i = 0; i < n; ++i) {
        t[i + sz] = dep[i];
    }
    for (int i = sz - 1; i >= 1; --i) {
        pull(i);
    }
}

int n, k;

constexpr int N = 2e5;
vector<int> adj[N];
int jump[N], depth[N], tin[N], tout[N], parent[N];

constexpr int M = 4e5;

pair<int, int> st[20][M];
int posi[M];

bool isp(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    a = posi[a], b = posi[b];
    if (a > b) swap(a, b);
    b += 1;
    int lg = __lg(b - a);
    return min(st[lg][a], st[lg][b - (1 << lg)]).second;
    while (!isp(a, b)) {
        if (isp(jump[a], b)) {
            a = parent[a];
        } else {
            a = jump[a];
        }
    }
    return a;
}

int la(int a, int b) {
    while (depth[a] > b) {
        if (depth[jump[a]] > b) {
            a = jump[a];
        } else {
            a = parent[a];
        }
    }
    return a;
}

int dist(int a, int b) {
    return depth[a] + depth[b] - 2 * depth[lca(a, b)];
}

bool play(int root, int mid) {
    vector<pair<int, ll>> colored;
    int cur = 0;
    int yay = -1;
    mid -= 1;
    ll atleast = 0;
    while (true) {
        auto [val, leaf] = t[1];
        int c = lca(leaf, root);
        if (val < atleast || depth[root] + depth[leaf] - 2 * depth[c] <= mid + 1) {
            yay = 1;
            break;
        }
        if (++cur > k) {
            yay = 0;
            break;
        }
        if (depth[leaf] - depth[c] > mid) {
            int v = la(leaf, depth[leaf] - mid);
            rangeApply(tin[v], tout[v], -inf);
            colored.push_back({v, -inf});
        } else {
            int aim = depth[c] + (mid - (depth[leaf] - depth[c]));
            int v = la(root, aim + 1);
            rangeApply(tin[v], tout[v], inf);
            atleast += inf;
            colored.push_back({v, inf});
        }
    }
    for (auto [x, y] : colored) {
        rangeApply(tin[x], tout[x], -y);
    }
    return yay;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

//    stress();
//    return 0;

    int tp;
    cin >> n >> k >> tp;
    if (n == 1) {
        assert(false);
    }
    k = min(k, n - 1);


    for (int i = 1; i < n; ++i) {
        int a, b;
        if (1) {
            cin >> a >> b;
        } else {
            a = i, b = i + 1;
        }
        a -= 1, b -= 1;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }

//    auto res = stupid(n, k, adj);
//    for (int i = 0; i < 1 + (tp == 0 ? 0 : n - 1); ++i) {
//        cout << res[i] << " ";
//    }
//    cout << endl;
//    return 0;

    vector<int> ord(n);
    int T = 0;
    int tST = 0;

    auto dfs = [&](auto self, int v) -> void {
        ord[tin[v] = T++] = v;
        st[0][tST++] = {depth[v], v};
        posi[v] = tST - 1;
        for (int to : adj[v]) {
            if (to == parent[v]) {
                continue;
            }
            parent[to] = v;
            depth[to] = depth[v] + 1;
            int p = jump[v];
            int pp = jump[p];
            if (depth[pp] - depth[p] == depth[p] - depth[v]) {
                jump[to] = pp;
            } else {
                jump[to] = v;
            }
            self(self, to);
            st[0][tST++] = {depth[v], v};
        }
        tout[v] = T;
    };

    dfs(dfs, 0);

    for (int i = 1; i < 20; ++i) {
        for (int j = 0; j + (1 << i - 1) <= tST; ++j) {
            st[i][j] = min(st[i - 1][j], st[i - 1][j + (1 << i - 1)]);
        }
    }

    vector<pair<int, int>> init(n);
    for (int i = 0; i < n; ++i) {
        init[i] = {depth[ord[i]] + inf, ord[i]};
    }
    build(init);

    vector<int> ans(n);

    auto dfs2 = [&](auto self, int v) -> void {
        int lo = 0, hi = n / k + 1;
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (play(v, mid)) {
                hi = mid;
            } else {
                lo = mid;
            }
        }
        ans[v] = hi;
        if (tp == 0) {
            return;
        }
        for (int to : adj[v]) {
            if (to == parent[v]) {
                continue;
            }
            rangeApply(tin[to], tout[to], -2);
            self(self, to);
            rangeApply(tin[to], tout[to], 2);
        }
    };

    dfs2(dfs2, 0);

    for (int i = 0; i < 1 + tp * (n - 1); ++i) {
        cout << ans[i] << " ";
    }
    cout << '\n';

    return 0;
}