#include <bits/stdc++.h>

using namespace std;
using ll = long long;

using P = pair<int, int>;
const P inf = {1e9, 1e9};
const P neut = {1, 1};
int n, k;

vector<P> unite(const vector<P> &a, const vector<P> &b) {
    if (a[0].first == 0) {
        return b;
    }
    if (b[0].first == 0) {
        return a;
    }
    vector<P> ans(k + 1, inf);
    for (int i = 0; i <= k; ++i) {
        for (int j = 0; j <= k - i; ++j) {
            ans[i + j] = min(ans[i + j], max(a[i], b[j]));
        }
    }
//    for (int i = k, j = k; i >= 0; --i) {
//        while (j >= 0 && b[j] <= a[i]) {
//            if (i + j <= k) {
//                ans[i + j] = min(ans[i + j], max(a[i], b[j]));
//            }
//            j -= 1;
//        }
//        if (i + j <= k && j >= 0) {
//            ans[i + j] = min(ans[i + j], max(a[i], b[j]));
//        }
//    }
    for (int i = 1; i <= k; ++i) {
        ans[i] = min(ans[i], ans[i - 1]);
    }
    return ans;
}

void nrm(vector<P> &a) {
    if (a[0].first == 0) {
        fill(a.begin(), a.end(), pair{1, -1});
        a[0] = {1, 1};
        return;
    }
    for (int i = k; i >= 0; --i) {
        a[i].second += 1;
        if (a[i].second < a[i].first) {
            if (i + 1 <= k) {
                a[i + 1] = min(a[i + 1], {a[i].first, -1});
            }
        }
        if (a[i].second <= a[i].first && i + 1 <= k) {
            a[i + 1] = min(a[i + 1], {a[i].first, -1});
        }
        if (i > 0 && a[i].second > a[i].first) {
            a[i] = inf;
        }
    }
    if (a[0].first > 1) {
        a[1] = min(a[1], {a[0].first, 1});
    }
    a[0] = {a[0].first + 1, a[0].first + 1};
    for (int i = 1; i <= k; ++i) {
        a[i] = min(a[i], {a[i - 1].first, -1});
    }
}

vector<vector<P>> dp;
vector<vector<int>> adj;
vector<int> ans;

void dfs1(int v) {
    for (int to : adj[v]) {
        adj[to].erase(find(adj[to].begin(), adj[to].end(), v));
        dfs1(to);
    }
    if (adj[v].empty()) {
        dp[v].assign(k + 1, {1, -1});
        dp[v][0] = {1, 1};
//        cout << "v: " << v << endl;
//        for (auto [x, y] : dp[v]) {
//            cout << x << " " << y << endl;
//        }
        return;
    }
    dp[v] = dp[adj[v][0]];
    for (int i = 1; i < size(adj[v]); ++i) {
        dp[v] = unite(dp[v], dp[adj[v][i]]);
    }
    nrm(dp[v]);
//    cout << "v: " << v << endl;
//    for (auto [x, y] : dp[v]) {
//        cout << x << " " << y << endl;
//    }
}

void dfs2(int v, vector<P> up) {
    vector<vector<P>> pref(size(adj[v]));
    for (int i = 0; i < size(adj[v]); ++i) {
        if (i > 0) {
            pref[i] = unite(pref[i - 1], dp[adj[v][i]]);
        } else {
            pref[i] = dp[adj[v][i]];
        }
    }
    for (int i = int(size(adj[v])) - 1; i >= 0; --i) {
        vector<P> nxt = i == 0 ? up : unite(up, pref[i - 1]);
        nrm(nxt);
        dfs2(adj[v][i], nxt);
        up = unite(up, dp[adj[v][i]]);
    }
//    nrm(up);
    ans[v] = up.back().first;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> n >> k >> t;
    if (n == 1) {
        cout << 0 << endl;
        return 0;
    }
    dp.resize(n), adj.resize(n), ans.resize(n);

    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        a -= 1, b -= 1;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }

    dfs1(0);
    dfs2(0, vector<P>(k + 1));
    for (int i = 0; i < 1 + t * (n - 1); ++i) {
        cout << ans[i] << " ";
    }
    cout << '\n';

    return 0;
}